
import java.util.Random;

/**
 * This class represents pld's numeric examples.
 *
 * 
 * @author  pld
 */
public class Numerics 
{
 
    /**
     * Constructor for objects of class Numerics
     */
    public Numerics()
    {
        // nothing to do... instance variables are automatically set to null
    }


/* */
    public void numtable() {
        int n=0;
        /* */
        for (n=0; n<=20; n=n+2) {
            System.out.println(n + "  " + n*n*n);
        }
        /* 
        while(n<=20) {
            System.out.println(n+"     "+n*n*n);
            n = n+1;
        }
        /* */
    }
    
    public void triangletable() {
        int row,col;
        for (row = 1; row <= 15; row++) {
            triangleRow(row*2);
        }
    }

    /**
     * Finds sum of 1+2+3+...+n
     */
    public int sumNums(int n) {
        int sum = 0;
        int i = 0;
        while (i<=n) {
            sum += i;
            i++;
        }
        return sum;
    }
    
    public void triangleRow(int width) {
        int col;
        for (col=0; col<width; col++) {
            System.out.print("*");
        }
        System.out.println();
    }
    
    public boolean isPrime(int n) {
        int div = 2;
        int top = n-1;  // top = (int) Math.sqrt(n)
        if (n==1) return false;
        while (div < top) {
            if (n % div == 0) return false;
            div ++;
        }
        return true;
    }
   

    // now *print* primes from 1 to 100:

    public void primeTable(int size) {
        int i = 1;
        while ( i<=size ) {
            if (isPrime(i)) {
                System.out.println("" + i + " is prime");
            }
            i++;
        }
    }
    
    void stringdemo() {
        String s = "hello";
        int i = 3;
        String u = s;
        String w=s;
        //u.replace('h', 'H');      // does nothing
        w = u.replace('h', 'H');
        System.out.println(u+w);
        w =u.toUpperCase();
        System.out.println(u + w);
    }
    
    // we choose random numbers 0..max-1, until we get to 0.
    // We return the number of tries needed.
    
    int randrunlen(int max) {
        Random r = new Random();
        int val = r.nextInt(max);
        int count = 1;
        while (val != 0) {
            val = r.nextInt(max);
            count++;
        }
        return count;
    }
    
    // randrunmax is like randrunlen, except that we return.
    // the largest "val" generated on the way.
    
    int randrunmax(int max) {
        Random r = new Random();
        int val = r.nextInt(max);
        int count = 1;
        int maxval = val;
        int maxcount = 1;
        while (val != 0) {
            val = r.nextInt(max);
            if (val>maxval) {
                maxval = val;
                maxcount = count;
            }
        }
        return maxval;
    }
    
    void randtester(int n) {
        int i;
        for (i=0; i<n; i++) {
            System.out.println(randrunmax(100));
        }
    }
    
    // run randrunlen(100) n times, return the longest run
    
    public int maxfinder(int n) {
        int i;
        int maxsofar = 0;
        for (i=1;i<=n; i++) {
            int m = randrunlen(100);
            if (m>maxsofar) maxsofar = m;
        }
        return maxsofar;
    }
    
    public int f1(int n) {return 111 + 127*n - n*n;}
    
    public int f2(int x) {return x*x*x - 150*x*x + 2700*x;}
    
    public int f3(int x) {return -f2(x);}
    
    public void maxfinder() {
        int i;
        int maxpos = 0;
        int maxval = 0;
        for (i=1; i<=100; i++) {
            int val = f3(i);
            if (val > maxval) {
                maxval = val;
                maxpos = i;
            }
        }
        System.out.println("max value = " + maxval + ", occurred at n="+maxpos);
    }
}
